*+
*+
*+    Source Module => D:\SRC\NGSRCHTM\TOKEN.PRG
*+
*+    Copyright (C) 1997, Phil Barnett. All Rights Reserved Worldwide.
*+
*+    Functions: Function token()
*+               Function numtoken()
*+
*+    Reformatted by Click! 2.02 on Jan-31-1999 at  9:24 pm
*+
*+

#include "COMMON.CH"

/*
*+
*+
*+    Function test()
*+
*+
*+
function test()

local x
local nHowMany       := numtoken( '  This    is   a  test,   eh?  ', ' ' )

? nHowMany

for x := 1 to nHowMany
   ? '<' + token( '  This    is   a  test,   eh?  ', ' ', x ) + '>'
next

? numtoken( '             ', ' ' )

? numtoken( '', ' ' )

return nil
*/

*+
*+
*+    Function token()
*+
*+    Called from ( ngsrchtm.prg )   2 - procedure ngsrchtm()
*+
*+
*+
function token( cString, cDelimiter, nPointer )

local x
local nStrLen      := len( cString )
local nHowMany     := 0
local nLastPointer := 0
local cPart
local lFoundWord   := .f.

default cDelimiter to ' ,.;:!?/\<>()^#&%+-*' + chr( 0 ) + chr( 9 ) + ;
        chr( 10 ) + chr( 13 ) + ;
        chr( 26 ) + chr( 138 ) + ;
        chr( 141 )

for x := 1 to nStrLen
   if substr( cString, x, 1 ) $ cDelimiter
      if lFoundWord
         nHowMany ++
      endif
      if nHowMany == nPointer
         exit
      endif
      do while x < nStrLen .and. substr( cString, x + 1, 1 ) $ cDelimiter
         x ++
      enddo
      nLastPointer := x
   else
      lFoundWord := .t.
   endif
next

if x == nStrLen + 1                     // went all the way without nHowmany == nPointer
   // take the last word
   cPart := substr( cString, nLastPointer + 1 )
else
   cPart := substr( cString, nLastPointer + 1, ( x - nLastPointer ) - 1 )
endif

return cPart

*+
*+
*+    Function numtoken()
*+
*+    Called from ( ngsrchtm.prg )   1 - procedure ngsrchtm()
*+
*+
*+
function numtoken( cString, cDelimiter )

local x
local nStrLen    := len( cString )
local nHowMany   := 0
local lFoundWord := .f.
local retval     := 0

default cDelimiter to ' ,.;:!?/\<>()^#&%+-*' + chr( 0 ) + chr( 9 ) + ;
        chr( 10 ) + chr( 13 ) + ;
        chr( 26 ) + chr( 138 ) + ;
        chr( 141 )

for x := 1 to nStrLen
   if substr( cString, x, 1 ) $ cDelimiter
      if lFoundWord
         nHowMany ++
      endif
      do while x < nStrLen .and. substr( cString, x + 1, 1 ) $ cDelimiter
         x ++
      enddo
   else
      lFoundWord := .t.
   endif
next

if nStrLen > 0
   retval := iif( right( cString, 1 ) $ cDelimiter, nHowmany, nHowMany + 1 )
endif

return retval

*+ EOF: TOKEN.PRG
